/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package operacije;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public abstract class Operacija {
    protected double operand1;
    protected double operand2;
    protected double rezultat;
    
    private void unesiVrednosti() throws Exception{
        BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
        try {
            String sOperand1=br.readLine();
            String sOperand2=br.readLine();
            izvrsiValidaciju(sOperand1, sOperand2);
            
        } catch (IOException ex) {
            System.err.println("GRESKA U CITANJU PODATAKA SA ULAZNOG TOKA. "+ex.getMessage());
            throw new Exception("Dogodila se greska prilikom rada sa tastaturom.");
        }
    }
    
    protected void izvrsiValidaciju(String s1, String s2) throws Exception{
        try{
            operand1=Double.parseDouble(s1);
            operand2=Double.parseDouble(s2);
        }catch(NumberFormatException nfe){
            System.err.println("GRESKA U KONVERZIJI TIPOVA PODATAKA. "+nfe.getMessage());
            throw new Exception("Dogodila se greska prilikom pretvaranja unosa ("+s1+", "+s2+") u brojeve.");
        }
    }
    
    protected abstract void izracunaj();
    
    protected abstract void prikaziRezultat();
    
    public void izvrsi(){
        try {
            unesiVrednosti();
            izracunaj();
            prikaziRezultat();
        } catch (Exception ex) {
            ex.getMessage();
        }
    }
    
}
